#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
B0[i] = B6[i]+B6[i]+B6[i]+B6[i];
B1[i] = B8[i];
B2[i] = B8[i];
B3[i] = B8[i]-B8[i]-B8[i];
B4[i] = B8[i];
B5[i] = B8[i]/B6[i]+B7[i]*B7[i];
}
}

int main(int argc,char **argv) {
int size=794938;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<794938;i++){
B0[i] = 53.1091030989+i+1;
B1[i] = 3.2153558519*i+1;
B2[i] = 41.6337255661*i+1;
B3[i] = 85.6901606739+i+1;
B4[i] = 66.8193193007*i+1;
B5[i] = 1.66000414898*i+1;
B6[i] = 29.8861699693*i+1;
B7[i] = 94.9767817175+i+1;
B8[i] = 69.4890402917*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(B0,B1,B2,B3,B4,B5,B6,B7,B8,794938);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }